/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
)

// checks if the LoyaltyPoints type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LoyaltyPoints{}

// LoyaltyPoints struct for LoyaltyPoints
type LoyaltyPoints struct {
	Name string `json:"name"`
	CurrentAmount int32 `json:"current_amount"`
	ContactId string `json:"contact_id"`
	ChannelId string `json:"channel_id"`
	OrganizationId string `json:"organization_id"`
	ConversationId string `json:"conversation_id"`
}

// NewLoyaltyPoints instantiates a new LoyaltyPoints object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLoyaltyPoints(name string, currentAmount int32, contactId string, channelId string, organizationId string, conversationId string) *LoyaltyPoints {
	this := LoyaltyPoints{}
	this.Name = name
	this.CurrentAmount = currentAmount
	this.ContactId = contactId
	this.ChannelId = channelId
	this.OrganizationId = organizationId
	this.ConversationId = conversationId
	return &this
}

// NewLoyaltyPointsWithDefaults instantiates a new LoyaltyPoints object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLoyaltyPointsWithDefaults() *LoyaltyPoints {
	this := LoyaltyPoints{}
	return &this
}

// GetName returns the Name field value
func (o *LoyaltyPoints) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPoints) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *LoyaltyPoints) SetName(v string) {
	o.Name = v
}

// GetCurrentAmount returns the CurrentAmount field value
func (o *LoyaltyPoints) GetCurrentAmount() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.CurrentAmount
}

// GetCurrentAmountOk returns a tuple with the CurrentAmount field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPoints) GetCurrentAmountOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CurrentAmount, true
}

// SetCurrentAmount sets field value
func (o *LoyaltyPoints) SetCurrentAmount(v int32) {
	o.CurrentAmount = v
}

// GetContactId returns the ContactId field value
func (o *LoyaltyPoints) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPoints) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *LoyaltyPoints) SetContactId(v string) {
	o.ContactId = v
}

// GetChannelId returns the ChannelId field value
func (o *LoyaltyPoints) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPoints) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *LoyaltyPoints) SetChannelId(v string) {
	o.ChannelId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *LoyaltyPoints) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPoints) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *LoyaltyPoints) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetConversationId returns the ConversationId field value
func (o *LoyaltyPoints) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPoints) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *LoyaltyPoints) SetConversationId(v string) {
	o.ConversationId = v
}

func (o LoyaltyPoints) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LoyaltyPoints) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["current_amount"] = o.CurrentAmount
	toSerialize["contact_id"] = o.ContactId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["conversation_id"] = o.ConversationId
	return toSerialize, nil
}

type NullableLoyaltyPoints struct {
	value *LoyaltyPoints
	isSet bool
}

func (v NullableLoyaltyPoints) Get() *LoyaltyPoints {
	return v.value
}

func (v *NullableLoyaltyPoints) Set(val *LoyaltyPoints) {
	v.value = val
	v.isSet = true
}

func (v NullableLoyaltyPoints) IsSet() bool {
	return v.isSet
}

func (v *NullableLoyaltyPoints) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLoyaltyPoints(val *LoyaltyPoints) *NullableLoyaltyPoints {
	return &NullableLoyaltyPoints{value: val, isSet: true}
}

func (v NullableLoyaltyPoints) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLoyaltyPoints) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


